local mod = RW:Boss("Lady Deathwhisper", "Icecrown Citadell", "Icecrown Citadell", "The Entryway")
local L

-- 3.3?
if not QueryQuestsCompleted then return end

---------------------
-- Variables

local tDominateDur, tDominateCD, iDominate, mDominate
local tDNDCD, tDNDDur, wDND
local tBerserk
local mPhase, wPhase

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Lady Deathwhisper"
		
		L_cat_CultAdherent = "Cult Adherent"
		L_cat_CultFanatic = "Cult Fanatic"
		
		L.mana_barrier = GetSpellInfo(70842)
		L.phasewarning = "Phase 2 Starting!"
		L.phasewarning_opt = "Phase Switch Warning"
	end
	L = mod:GetLocale()
	mod.L = L
	
	mod:SetTrigger(36855)
	mod:SetWin()
	
	self:AddCategory(L.name, "Adds")
	self:AddSpellOption(L.name, 70842)
	
	self:AddBoolOption("ManaShieldHelath", "Show Mana Barrier health", L.name, true)
	
	tDominateDur	= self:DurTargetTimer(20, 71289)
	tDominateCD		= self:CDTimer(40, 71289)
	tDNDCD			= self:CDTimer(20, 72109)
	tDNDDur			= self:DurTimer(10, 72109)
	tBerserk		= self:BerserkTimer(600)
	
	wDND			= self:RunawayWarning(72109)
	wPhase			= self:Warning({L.phasewarning, L.phasewarning}, [[Interface\Icons\Achievement_PVP_A_02.blp]], L.phasewarning_opt)
	
	mDominate		= self:TargetMessage(71289)
	mPhase 			= self:PhaseMessage()
	
	iDominate		= self:Icon("SKULL", 71289, mil, false, "CROSS", "SQUARE")
end

----------------------
-- Locals

local manaLeft
local mcTargets = {}

local function ManaBarrierUpdate()
	local uID = mod:UIDFromCID(36855)
	if uID then
		manaLeft = UnitMana(uID) / UnitManaMax(uID)
	end
	return manaLeft
end

----------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Dominate", 71289)
	self:Track("DND", 72109, 72108)
	self:Track("ManaBarrier", 70842)
	
	tBerserk:Start()
	
	if self.db.profile.ManaShieldHelath then
		self:SendMessage("RW_AddHealthFrame", ManaBarrierUpdate, L.mana_barrier)
	end
	
	manaLeft = 1
	wipe(mcTargets)
end

local function showMCTargets()
	mDominate:Show(table.concat(mcTargets, "<, >"))
	wipe(mcTargets)
end

function mod:Dominate(event, args)
	if event == "SPELL_AURA_APPLIED" then
		tDominateDur:Start(args.dName)
		tDominateCD:Start()
		iDominate:Show(args.dName)
		
		mcTargets[#mcTargets + 1] = args.dName
		self:Schedule("MCTargets", 0.2, showMCTargets)
		
	elseif event == "SPELL_AURA_REMOVED" then
		iDominate:Hide(args.dName)
		tDominateDur:Cancel(args.dName)
	end
end

function mod:DND(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tDNDCD:Start()
		tDNDDur:Start()
		
	elseif event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wDND:Show()
		end
	end
end

function mod:ManaBarrier(event, args)
	if event == "SPELL_AURA_REMOVED" then
		mPhase:Show(2)
		wPhase:Show()
		self:SendMessage("RW_RemoveAllHealthFrames")
	end
end