local mod = RW:Boss("Lord Marrowgar", "Icecrown Citadell", "Icecrown Citadell", "The Entryway")
local L

-- 3.3?
if not QueryQuestsCompleted then return end

------------------------------------
-- Variables

local tBoneStormCD, tBoneStormDur
local mBoneStormSoon
local wFlame, wBStorm
local iImpaled
local mImpaled

-----------------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Lord Marrowgar"
		
		L.bonestomr_trigger = "%s creates a whirling storm of bone!"
		
		L.bonestorm_soon = "Bone storm in 10s!"
		L.bonestorm_soon_opt = "10s warning"
	end
	L = mod:GetLocale()
	mod.L = L
	
	mod:SetTrigger(36612)
	mod:SetWin(36612)
	
	tBoneStormCD, tBoneStormDur = self:CDTimer(65, 69076), self:DurTimer(25, 69076)
	
	wFlame	= self:RunawayWarning(69146)
	wBStorm = self:RunawayWarning(69076)
	
	mBoneStormSoon = self:CustomMessage({L.bonestorm_soon, L.bonestorm_soon_opt}, 69076)
	mImpaled		= self:TargetMessage(69065)
	
	iImpaled = self:Icon("STAR", 69065, nil, nil, "CROSS", "SQUARE")
end

-----------------------------------------
-- locals

local flameSpamm = 0
local impaleTargets

-----------------------------------------
-- Start

function mod:OnEngage()
	self:Track("BoneStorm", 69076)
	self:Track("Flame", 69146, 70825, 70824, 70823)
	self:Track("Impaled", 69065)
	
	impaleTargets = impaleTargets or {}
	wipe(impaleTargets)
	
	tBoneStormCD:Start(45)
	mBoneStormSoon:Schedule(35)
end

function mod:BoneStorm(event, args)
	if event == "SPELL_CAST_START" then
		wBStorm:Show()
		tBoneStormCD:Stop()
		
	elseif event == "SPELL_AURA_APPLIED" then
		tBoneStormDur:Start()
	elseif event == "SPELL_AURA_REMOVED" then
		tBoneStormCD:Start()
		mBoneStormSoon:Schedule(55)
	end
end

function mod:Flame(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			if GetTime() - flameSpamm > 4 then
				wFlame:Show()
				flameSpamm = GetTime()
			end
		end
	end
end

function mod:ShowImpaled()
	mImpaled:Show(table.concat(impaleTargets, "<, >"))
	wipe(impaleTargets)
end

function mod:Impaled(event, args)
	if event == "SPELL_AURA_APPLIED" then
		impaleTargets[#impaleTargets + 1] = args.dName
		self:Schedule("SHowImpaled", 1, "ShowImpaled")
		iImpaled:Show(args.dName)
	elseif event == "SPELL_AURA_REMOVED" then
		iImpaled:Hide(args.dName)
	end
end

